



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Django基础和基本使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Django基础和基本使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 13:25:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<table>
<tbody>
<tr>
<td><strong>Django基础</strong></td>
</tr>
</tbody>
</table>
<p>Django是Python下的一款著名的Web框架</p>
<p><strong>框架</strong></p>
<p>任何语言进入到高级部分时，会有认证、session、http、连接数据库等等功能操作，没有框架时需要自己实现</p>
<p>框架 是整个或部分系统的可重用设计，表现为一组抽象组件及组件实例间交互的方法；</p>
<p><strong>Django优点</strong></p>
<ul><li><p>自带轮子众多，方便快速开发 如Auth，Cache，模板等</p></li>
<li><p>天生的MVC设计模块</p></li>
<li><p>实用的后台管理</p></li>
<li><p>自带ORM，Template，Form，Auth核心组件</p></li>
<li><p>简洁的url设计</p></li>
<li><p>周边插件丰富</p></li></ul>
<p><strong>Django缺点</strong></p>
<ul><li><p>重</p></li>
<li><p>同步阻塞</p></li></ul>
<p><strong>和其他Web框架对比</strong></p>
<ul><li><p>Flask：小而精</p></li>
<li><p>Tornado：基于事件，异步</p></li></ul>
<p><strong>Django设计哲学</strong></p>
<ul><li><p>大而全</p></li>
<li><p>快速开发</p></li></ul>
<p><strong>Django历史</strong></p>
<p>最初开发者：Adrian和Simon</p>
<p>开发背景：World Online维护几个新闻站点，要求快速发布新闻，快速建立其他新闻站点(快速开发，数据驱动)</p>
<p>开源时间：2005年夏天 World Online小组宣布开源</p>
<p>官方网站：<a href="https://www.djangoproject.com" rel="external nofollow noreferrer">https://www.djangoproject.com</a></p>
<p>文档地址：<a href="https://docs.djangoproject.com/en/1.11/" rel="external nofollow noreferrer">https://docs.djangoproject.com/en/1.11/</a></p>
<p><strong>Django安装</strong></p>
<p>使用版本 Django 1.11 &nbsp;Python3.5.2</p>
<div>
<pre class="prettyprint linenums">pip  install  -i  https://pypi.doubanio.com/simple/  --trusted-host pypi.doubanio.com django<br />
python -c "import django; print(django.get_version())"</pre>
</div>
<p>需求：web页面要求列出最新10本书</p>
<p><strong>Django Model - models.py</strong></p>
<p>用一个Python类来描述数据表，我们称之为模型(model)</p>
<p>运用这个类，你可以通过简单的Python代码来创建、检索、更新、删除数据库中的记录而无需写一条又一条的SQL语句</p>
<p>这就是传说中的ORM(Object Relation Mapping)　　</p>
<p># 数据</p>
<div>
<pre class="prettyprint linenums">from django.db import models

class Book(models.Model):<br />
    name = models.CharField(max_length=50)<br />
    pub_date = models.DateField()</pre>
</div>
<p><strong>Django View - view.py</strong></p>
<p>View 包含了项目的业务逻辑，我们称之为视图，也是我们开发过程中主要编写的内容</p>
<p># 算法</p>
<div>
<pre class="prettyprint linenums">from django.shortcuts import render<br />
from models import Book

def latest_books(request):<br />
   book_list = Book.objects.order_by('-pub_date')[:10]<br />
   return render(request, 'latest_books.html', {'book_list': book_list})</pre>
</div>
<p><strong>Django UrlConf - urls.py</strong></p>
<p>指出了什么样的URL调用什么样的视图，如 /latest/ &nbsp;调用 &nbsp;latest_books()这个函数</p>
<p>如果你的域名是 example.com，任何人浏览 http://example.com/latest/ 将会调用latest_books()这个函数的返回结果给用户</p>
<p># 路径</p>
<div>
<pre class="prettyprint linenums">from django.conf.urls import url<br />
import views

urlpatterns = [<br />
    url(r'^latest/$', views.latest_books),<br />
]</pre>
</div>
<p><strong>Django Template</strong></p>
<p>简单来说就是html模板，它描述了项目的界面结构。模板引擎也内置了一些tag</p>
<p># &nbsp;前端展示</p>
<div>
<pre class="prettyprint linenums">&lt;ul&gt;<br />
{% for book in book_list%}<br />
    &lt;li&gt;{{ book.name }}&lt;/li&gt;<br />
{% endfor %}<br />
&lt;/ul&gt;</pre>
</div>
<p>基本相应流程</p>
<table>
<tbody>
<tr>
<td><strong>Django基本使用</strong></td>
</tr>
</tbody>
</table>
<p>需求：</p>
<ul><li><p>查看所有问题</p></li>
<li><p>可以让用户投票</p></li>
<li><p>可以查看投票结果</p></li></ul>
<p><strong>一 &nbsp; 项目 Project</strong></p>
<p>1. 新建项目</p>
<div>
<pre class="prettyprint linenums">django-admin startproject mysite</pre>
</div>
<p>2. 运行项目</p>
<div>
<pre class="prettyprint linenums">python manage.py runserver 0.0.0.0:8000</pre>
</div>
<ul><li><p>启动的是django内置的webserver，仅用于开发测试</p></li>
<li><p>更改py文件后server会自动reload</p></li></ul>
<p>3. Django项目目录结构</p>
<div>
<pre class="prettyprint linenums">mysite<br />
|--manage.py  # 管理工具：运行项目、迁移数据<br />
|--mysite     # 项目配置信息目录<br />
|--urls       # 项目urls入口，分发<br />
|--wsgi       # wsgi部署</pre>
</div>
<p>4. &nbsp;Hello World实现</p>
<div>
<pre class="prettyprint linenums">from django.conf.urls import url<br />
from django.contrib import admin<br />
from django.http import HttpResponse

def index(request):<br />
    return HttpResponse('This is index page')

def hello(request):<br />
    return HttpResponse('Hello World')

urlpatterns = [<br />
    url(r'^admin/', admin.site.urls),<br />
    url(r'^$', index),<br />
    url(r'^hello/$', hello),<br />
]</pre>
</div>
<ul><li><p>urlpatterns</p></li>
<li><p>url函数(regex, view, kwargs=None, name=None)</p></li>
<li><p>注意是view function object而不是执行函数</p></li>
<li><p>前面的/和 和后面/</p></li>
<li><p>项目入口 urls</p></li>
<li><p>request view第一个参数永远是request(不探讨CBV)</p></li>
<li><p>HttpResponse (view永远返回一个Response对象，显示或隐式)</p></li></ul>
<p><strong>二 &nbsp; Django App</strong></p>
<p>1. 与project的关系和区别</p>
<ul><li><p>project 公司 &nbsp;app 公司team；project用于配置 app用于实现</p></li>
<li><p>app中才能使用model</p></li>
<li><p>app设计是可以插拔的，app不一定在project目录中，app之间尽量不要耦合太多</p></li></ul>
<p>2. 新建app</p>
<p>python manage.py startapp polls</p>
<p>3. &nbsp;App 目录结构</p>
<div>
<pre class="prettyprint linenums">polls          # app目录<br />
|--admin.py    # 内置后台管理配置<br />
|--apps        # app配置<br />
|--migrations  # ORM版本控制，迁移的各类数据<br />
|--models.py   # 数据模型定义，只有app才有<br />
|--test.py     # 单元测试<br />
|--views.py    # app的views函数</pre>
</div>
<p>4. 项目关联app，配置project settings 导入app</p>
<div>
<pre class="prettyprint linenums">INSTALLED_APPS = [<br />
    'django.contrib.admin',<br />
    'django.contrib.auth',<br />
    'django.contrib.contenttypes',<br />
    'django.contrib.sessions',<br />
    'django.contrib.messages',<br />
    'django.contrib.staticfiles',<br />
    'polls',<br />
]</pre>
</div>
<p>5. 编写app view</p>
<div>
<pre class="prettyprint linenums">from django.shortcuts import render, HttpResponse, redirect

def index(request):<br />
    return HttpResponse('This is index page')

def hello(request):<br />
    return HttpResponse('Hello World')</pre>
</div>
<p>6. 编写urls</p>
<p>app urls 注册到 项目urls中，各app之间项目独立，分发思想</p>
<div>
<pre class="prettyprint linenums">from django.conf.urls import url, include<br />
from django.contrib import admin

urlpatterns = [<br />
    url(r'^admin/', admin.site.urls),<br />
    url(r'^polls/', include('polls.urls'))<br />
]</pre>
</div>
<p>polls/urls.py 默认是不存在的，需要创建</p>
<div>
<pre class="prettyprint linenums">from django.conf.urls import url<br />
from polls import views

urlpatterns = [<br />
    url(r'^$', views.index),<br />
    url(r'^hello/', views.hello)<br />
]</pre>
</div>
<p><strong>三 &nbsp; Django 使用数据库</strong></p>
<p>支持的数据库</p>
<ul><li><p>SQLite</p></li>
<li><p>MySQL(MariaDB)</p></li>
<li><p>PostgreSQL</p></li>
<li><p>Oracle</p></li></ul>
<p>设置使用数据库</p>
<div>
<pre class="prettyprint linenums">DATABASES = {<br />
    'default': {<br />
        'ENGINE': 'django.db.backends.mysql', #数据库引擎<br />
        'NAME': 'db_name',                    #数据库名<br />
        'USER': 'root',                       #用户名<br />
        'PASSWORD': 'root',                   #密码<br />
        'HOST': 'localhost',                  #数据库主机，默认为localhost<br />
        'PORT': '',                       #数据库端口，MySQL默认为3306<br />
        'OPTIONS': {<br />
            'autocommit': True,<br />
        },<br />
    }<br />
}</pre>
</div>
<p>Python 3.5+不支持MySQLdb驱动，可选方案：</p>
<ul><li><p>pymysql，python写的，速度慢，在站点__init__.py文件中，添加代码 import pymysql; pymysql.install_as_MySQLdb()</p></li>
<li><p>mysqlclient fork的 mysqldb支持python3.3+速度快，官方推荐&nbsp;https://pypi.python.org/pypi/mysqlclient/</p></li>
<li><p>在对db没有要求的情况下，postgre或许是个更好的选择 &nbsp;https://docs.djangoproject.com/en/1.11/ref/databases/</p></li></ul>
<p><strong>编写App models</strong></p>
<p>ORM用python方法、数据结构访问db，不用写SQL</p>
<p>可以兼容不同数据库</p>
<div>
<pre class="prettyprint linenums"># polls/models.py<br />
from django.db import models

class Question(models.Model):<br />
    question_text = models.CharField(max_length=200)<br />
    pub_date = models.DateTimeField('date published')

class Choice(models.Model):<br />
    question = models.ForeignKey('Question', on_delete=models.CASCADE)<br />
    choice_text = models.CharField(max_length=200)<br />
    votes = models.IntegerField(default=0)</pre>
</div>
<p>说明</p>
<ul><li><p>models.Model &nbsp; 继承父类的属性和方法，继承优势</p></li>
<li><p>CharField &nbsp; &nbsp; &nbsp; &nbsp; varchar()</p></li>
<li><p>DateTimeField datetime</p></li>
<li><p>IntegerField &nbsp; &nbsp; int</p></li>
<li><p>ForeignKey &nbsp; &nbsp; &nbsp;一对多关系 &nbsp; question_id</p></li>
<li><p>on_delete &nbsp; &nbsp; &nbsp; 是否级联删除</p></li>
<li><p>max_length</p></li>
<li><p>default</p></li>
<li><p>blank</p></li>
<li><p>null</p></li></ul>
<p><strong>Models Migrate</strong></p>
<p>编写完数据模型需要应用到数据库，Django为了能跟踪表结构的变化，增加了migrations版本控制功能</p>
<p>如果没有该功能，每次表结构发生变化，就需要重新生成表结构，重新导入数据</p>
<p>python manage.py makemigrations</p>
<p>python manage.py migrate</p>
<p>python manage.py shell</p>
<ul><li><p>一个class代表一张表(多对多会产生额外一张关系表)</p></li>
<li><p>默认主键为id，也可以自定义主键</p></li>
<li><p>表名默认为 app名称_类名.lower()，可以重写</p></li></ul>
<p><strong>Models增删改查</strong></p>
<p>增：</p>
<div>
<pre class="prettyprint linenums">q = models.Question(**kwargs)<br />
q.save()

q = models.Question.objects.create(**kwargs)</pre>
</div>
<p>查：</p>
<div>
<pre class="prettyprint linenums">models.Question.objects.all()    # 查询所有<br />
models.Question.objects.filter(question_text="What's up?")<br />
models.Question.objects.get(id=1)</pre>
</div>
<p>改：</p>
<div>
<pre class="prettyprint linenums">q = models.Question.objects.get(id=1)<br />
q.question_text = "some text"<br />
q.save()

models.Question.objects.filter(id=1).update(question_text="Why?")</pre>
</div>
<p>删：</p>
<div>
<pre class="prettyprint linenums">q = models.Question.objects.get(id=1)<br />
q.delete()

models.Question.objects.get(id=1).delete()<br />
models.Question.objects.all().delete()</pre>
</div>
<p>说明：</p>
<ul><li><p>def __unicode__(self):pass</p></li>
<li><p>__str__ = __unicode__</p></li>
<li><p>timezone带来的问题</p></li></ul>
<p><strong>View中使用Model</strong></p>
<p>需求列出最近5个问题</p>
<div>
<pre class="prettyprint linenums">def index(request):<br />
    latest_question_list = models.Question.objects.order_by('-pub_date')[:5]<br />
    output = ','.join([q.question_text for q in latest_question_list ])<br />
    return HttpResponse(output)</pre>
</div>
<p>完成详情，提供投票，显示投票结果</p>
<div>
<pre class="prettyprint linenums"># polls/views.py<br />
def detail(request, question_id):<br />
    return HttpResponse('You are looking at question {}'.format(question_id))

def results(request, question_id):<br />
    return HttpResponse('You are looking at results of question {}'.format(question_id))

def vote(request, question_id):<br />
    return HttpResponse('You are voting on question {}'.format(question_id))

# polls/urls.py<br />
urlpatterns = [<br />
    url(r'^(?P&lt;question_id&gt;[0-9]+)/$', views.detail, name='detail'),<br />
    url(r'^(?P&lt;question_id&gt;[0-9]+)/results/$', views.results, name='results'),<br />
    url(r'^(?P&lt;question_id&gt;[0-9]+)/vote/$', views.vote, name='vote'),<br />
]</pre>
</div>
<p>说明</p>
<ul><li><p>(?P&lt;question_id&gt;[0-9]+)----&gt;关键字参数传入views函数中；对应()位置参数形式传入views函数中</p></li>
<li><p>detail(request, question_id)</p></li>
<li><p>args, kwargs 总是 字符串</p></li></ul>
<p><strong>四 &nbsp; 模板Template</strong></p>
<p>Django内置了自己的模板引擎，和jinja很像，使用简单</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; from django.template import Template, Context<br />
&gt;&gt;&gt; t = Template("My name is {{ name }}")<br />
&gt;&gt;&gt; c = Context({"name":"Jonathan"})<br />
&gt;&gt;&gt; t.render(c)</pre>
</div>
<p>模板使用变量，小数点新式</p>
<ul><li><p>字典</p></li>
<li><p>属性</p></li>
<li><p>方法，无参数</p></li>
<li><p>列表/元组，list1.0</p></li></ul>
<p>模板引擎还支持过滤器和循环判断</p>
<p>for循环</p>
<div>
<pre class="prettyprint linenums">{% for person in person_list%}<br />
&lt;li&gt;{{ person.name }}&lt;/li&gt;<br />
{% endfor%}</pre>
</div>
<p>if判断</p>
<div>
<pre class="prettyprint linenums">{% if max &gt; 10%}<br />
&lt;li&gt;最大值 {{ max }}&lt;/li&gt;<br />
{% else %}<br />
&lt;li&gt;最大值10&lt;/li&gt;<br />
{% endif%}</pre>
</div>
<p>过滤器，本质函数</p>
<div>
<pre class="prettyprint linenums">{{ now | date:"F j,Y"}}<br />
{{ name | length}}</pre>
</div>
<p><strong>View中使用模板</strong></p>
<p>Django默认会去app/templates下寻找模板，默认会去app/static中寻找静态文件(css, js, jpg)</p>
<p>模板+上下文---&gt;渲染---&gt;HTML文档</p>
<p>version 1:</p>
<div>
<pre class="prettyprint linenums">def index(request):<br />
    latest_question_list = models.Question.objects.order_by('-pub_date')[:5]<br />
    template = Template("""<br />
    &lt;img src="/static/django.png"&gt;<br />
    {% if latest_question_list %}<br />
    &lt;ul&gt;<br />
    {% for question in latest_question_list %}<br />
    &lt;li&gt;&lt;a href="/polls/{{ question.id }}/"&gt;{{ question.question_text }}&lt;/a&gt;&lt;/li&gt;<br />
    {% endfor %}<br />
    &lt;/ul&gt;<br />
    {% endif%}<br />
    """)<br />
    context = Context({'latest_question_list':latest_question_list})<br />
    return HttpResponse(template.render(context))</pre>
</div>
<p>version 2：</p>
<div>
<pre class="prettyprint linenums"># templates/polls/index.html<br />
&lt; img src = "/static/django.png" &gt;<br />
{ % if latest_question_list %}<br />
&lt; ul &gt;<br />
{ % for question in latest_question_list %}<br />
&lt; li &gt; &lt; a href = "/polls/{{ question.id }}/" &gt; {{question.question_text}} &lt; / a &gt; &lt; / li &gt;<br />
{ % endfor %}<br />
&lt; / ul &gt;<br />
{ % endif %}

# polls/views.py<br />
from django.template import loader<br />
def index(request):<br />
    latest_question_list = models.Question.objects.order_by('-pub_date')[:5]<br />
    template = loader.get_template('polls/index.html')<br />
    context = Context({'latest_question_list':latest_question_list})<br />
    return HttpResponse(template.render(context))</pre>
</div>
<p>version 3：</p>
<div>
<pre class="prettyprint linenums">from django.shortcuts import render

def index(request):<br />
    latest_question_list = models.Question.objects.order_by('-pub_date')[:5]<br />
    context = Context({'latest_question_list':latest_question_list})<br />
    return render(request, 'polls/index.html', context)</pre>
</div>
<p>设置公用 templates和static</p>
<div>
<pre class="prettyprint linenums">TEMPLATES = [<br />
    {<br />
        'BACKEND': 'django.template.backends.django.DjangoTemplates',<br />
        'DIRS': [os.path.join(BASE_DIR, 'templates')]<br />
        ,<br />
        'APP_DIRS': True,<br />
        'OPTIONS': {<br />
            'context_processors': [<br />
                'django.template.context_processors.debug',<br />
                'django.template.context_processors.request',<br />
                'django.contrib.auth.context_processors.auth',<br />
                'django.contrib.messages.context_processors.messages',<br />
            ],<br />
        },<br />
    },<br />
]

STATIC_URL = '/static/'<br />
STATICFILES_DIRS = (<br />
    os.path.join(BASE_DIR, 'static'),<br />
)</pre>
</div>
<p><strong>去掉url和static硬编码</strong></p>
<p>if、 for、 url 模板默认tag，static 不是，需要{% load static %}</p>
<div>
<pre class="prettyprint linenums">{% load static %}

&lt;img src="{% static 'django.png' %}"&gt;<br />
 {% if latest_question_list %}<br />
 &lt;ul&gt;<br />
 {% for question in latest_question_list %}<br />
 &lt;li&gt;&lt;a href="{% url 'detail' question.id %}"&gt;{{ question.question_text }}&lt;/a&gt;&lt;/li&gt;<br />
 {% endfor %}<br />
 &lt;/ul&gt;<br />
{% endif %}</pre>
</div>
<p><strong>url 反解析</strong></p>
<p>正解析：url -&gt; view</p>
<p>反解析：view name -&gt; url</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1092581/201709/1092581-20170906150122460-273211310.png" /></p>
<p>说明：</p>
<p>reverse</p>
<p>reverse_lazy</p>
<p><strong>url命名空间</strong></p>
<p>app namespace</p>
<p>定义方法一</p>
<div>
<pre class="prettyprint linenums"># polls/urls.py

app_name = 'polls'</pre>
</div>
<p>定义方法二</p>
<div>
<pre class="prettyprint linenums"># mysite/urls.py

url(r'^polls/', include('polls.urls', app_name='polls')</pre>
</div>
<p>instance namespace</p>
<p>定义</p>
<div>
<pre class="prettyprint linenums"># mysite/urls.py

url(r'^polls/', include('polls.urls', namespace='polls')</pre>
</div>
<p>测试</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1092581/201709/1092581-20170906151144226-1370121204.png" /></p>
<p>或者</p>
<p>reverse('polls:detail', args(1,))</p>
<p>通常使用app namespace，如果app有多个include，api_urls和view_urls则使用instance namespace</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1092581/201709/1092581-20170906152643194-2093031918.png" /></p>
<p><strong>五 &nbsp; &nbsp;form 处理</strong></p>
<p><strong>1. &nbsp;vote页面</strong></p>
<div>
<pre class="prettyprint linenums"># polls/detail.html

&lt;h1&gt;{{ question.question_text }}&lt;/h1&gt;<br />
{% if error_message %}&lt;p&gt;&lt;strong&gt;{{ error_message }}&lt;/strong&gt;&lt;/p&gt;{% endif %}

&lt;form action="{% url 'polls:vote' question.id %}" method="post"&gt;<br />
{% csrf_token %}<br />
{% for choice in question.choice_set.all %}<br />
    &lt;input type="radio" name="choice" id="choice{{ forloop.counter }}" value="{{ choice.id }}"/&gt;<br />
    &lt;label for="choice{{ forloop.counter }}"&gt;{{ choice.choice_text }}&lt;/label&gt;&lt;br/&gt;<br />
{% endfor %}<br />
&lt;input type="submit" value="Vote"/&gt;<br />
&lt;/form&gt;

# polls/view.py

from django.shortcuts import render, get_object_or_404, reverse<br />
from django.http import HttpResponseRedirect, HttpResponse<br />
from polls import models

def vote(request, question_id):<br />
    question = get_object_or_404(models.Question, pk=question_id)

    if request.method == 'POST':<br />
        choice_id = request.POST.get('choice', 0)<br />
        try:<br />
            selected_choice = question.choice_set.get(pk=choice_id)<br />
        except models.Choice.DoesNotExist:<br />
            return render(request, 'polls/detail.html',{<br />
                'question': question,<br />
                'error_message': "没有选择选项"<br />
            })<br />
        else:<br />
            selected_choice.votes += 1<br />
            selected_choice.save()<br />
            return HttpResponseRedirect(reverse('polls:results', args=(question.id,)))

    elif request.method == 'GET':<br />
        return render(request, 'polls/detail.html',{<br />
            'question': question,<br />
            'error_message': None<br />
        })</pre>
</div>
<p>说明：</p>
<p>request.POST 取用户form表单提交的数据；兼容request.GET</p>
<p>csrf_token &nbsp;每个表单生成一个标识值，中间件验证</p>
<p>request.FILES &nbsp;取文件</p>
<p>request.GET</p>
<p>models.Choice.DoesNotExist &nbsp;继承了models.Model；或导入DoesNotExist类</p>
<p>HttpResponseRedirect &nbsp; 快捷键 redirect</p>
<p>get_object_or_404</p>
<p>get_list_or_404</p>
<p>request</p>
<p>　　MEAT, HTTP_REFERER, &nbsp;HTTP_USER_AGENT, REMOTE_ADDR</p>
<p>　　schema, method, COOKIES, FILES</p>
<p>　　path, get_host, get_full_path, is_secure</p>
<p><strong>2. &nbsp;results 页面</strong></p>
<div>
<pre class="prettyprint linenums"># polls/views.py

from django.shortcuts import render, get_object_or_404<br />
def results(request, question_id):<br />
    question = get_object_or_404(models.Question, pk=question_id)<br />
    return render(request, 'polls/results.html',{'question': question})

# polls/results.html<br />
&lt;h1&gt;{{ question.question_text }}&lt;/h1&gt;<br />
&lt;ul&gt;<br />
    {% for choice in question.choice_set.all %}<br />
        &lt;li&gt;{{ choice.choice_text }} -- {{ choice.votes }} vote{{ choice.votes| pluralize }}&lt;/li&gt;<br />
    {% endfor %}<br />
&lt;/ul&gt;<br />
&lt;a href="{% url 'polls:vote' question.id %}"&gt;Vote again?&lt;/a&gt;</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8koworq.html">Android开发：关于WebView</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96733v8.html">保证唯一的一种js提交数据方式，还不错</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2vepl8.html">windows 环境下wamp环境的搭建。</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlr2pxq.html">简述UICollectionView 使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv4lyyq.html">ExtJS之开篇：我来了</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdd3ny8.html">MapReduce 重要组件&mdash;&mdash;Recordreader组件 &lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xp3jw9.html">mysql实体关系&lpar;mysql学习五&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xnnjg9.html">SSAS中Cube的结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn6mlz8.html">Demo学习： ClientEvents</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1rgm1q.html">EJB系列 - 消息与MDB</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6oml8.html">docker：（4）利用WebHook实现持续集成</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjevek8.html">Taurus&period;MVC 2&period;2&period;3&period;4 ：WebAPI 实现权限控制认证（及功能增强说明）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp43vxq.html">DataReport使用手记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjprmk8.html">YOU种你来丨i春秋校园行第一站北京电子科技学院</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojx6p1q.html">CentOS 7 部署Gitlab&plus;Jenkins持续集成&lpar;CI&rpar;环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllmo21q.html">vue&period;js 视频教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rz0x48.html">mysql通过now&lpar;&rpar;获取的时间不对</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o00318.html">JVM 字节码（一）字节码规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/960244j9.html">verilog语法实例学习&lpar;13&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/953rrgz8.html">【转】Spring学习---SpringIOC容器的初始化过程</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/95gz5ovq.html">Java 详解 JVM 工作原理和流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy0w0mq.html">QTP 学习 - 对象库</a>
			</li>
						<li><a href="https://www.batexi.com/a/960zojv9.html">TCARS&colon; Time- and Community-Aware Recommendation  System&lpar;时间感知和社区感知推荐系统&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2rne2q.html">32&period; linux下oracle数据库定时备份</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2rnj2q.html">Ubuntu 14&period;03  安装mysql</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4j3zzjq.html">python 的深浅copy</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25yjloq.html">Python 高阶函数map&lpar;&rpar;，filter&lpar;&rpar;，reduce&lpar;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5k5yeq.html">fastJson注解&commat;JSONField使用的一个实例</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdzdvz9.html">xtrabackup备份还原MySQL数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/960z3w49.html">3、支付结果 &sol;items&sol;result&quest;point&equals;1&amp;amp&semi;orderNo&equals;201903211035400001</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
